/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2011 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

#ifndef TOPPERS_TASK_H
#define TOPPERS_TASK_H

#include "kernel_impl.h"


/*
 *  ^XNDx̓\EO\ϊ}N
 */
#define INT_PRIORITY(x)		((uint_t)((x) - TMIN_TPRI))

/*
 *  ^XNID̍őlikernel_cfg.cj
 */
extern const ID	tmax_tskid;

/*
 *  ^XN̐
 */
#define tnum_tsk	((uint_t)(tmax_tskid - TMIN_TSKID + 1))

/*
 *  s\Ԃ̃^XNȂɎs^XŇݗDxɐݒ肷l
 */
#define TSKPRI_NULL		(UINT_MAX)


/*
 *  fBL[T[`̂߂̃rbg}bv
 */
extern volatile uint_t	ready_primap;

/*
 *  NvL[CÕrbg}bv
 */
extern uint_t	actque_bitmap;

/*
 *  fBXpb`^^XNO[`NvtO
 *
 *  ݃nh^CPUOnh̏oɁCfBXpb`܂
 *  ^XNO[`̋Nv邱ƂtOD
 */
extern bool_t	reqflg;

/*
 *  fBXpb`֎~
 *
 *  fBXpb`֎~Ԃł邱ƂtOD
 */
extern bool_t	disdsp;

/*
 *  sԃ^XŇݗDx
 *
 *  s̃^XNɎsDxݒ肳ĂΎsDxC
 *  ݒ肳ĂȂ΋NDxݒ肳D
 */
extern uint_t runtsk_curpri;

/*
 *  sԃ^XN̋NDx
 */
extern uint_t runtsk_ipri;

/*
 *  ^XNǗW[̏
 *
 *  SẴ^XNDe^XN̓^XNTA_ACTݒ肳Ă
 *  s\ԁCłȂꍇ͋x~ԂƂȂD
 *  
 *  ܂AfBXpb`tOfBXpb`Ԃɐݒ肷D
 *  
 *  {֐̓RtBM[^object_initializeȊOŌĂł͂ȂȂD
 */
extern void initialize_task(void);

/*
 *  ^XN̋N
 *
 *  ipriŎw肵NDx^XNs\ԂɑJڂD
 *  {֐s邱ƂɂvGvgꍇtrueC
 *  łȂꍇfalseԂD
 *
 *  {֐CPUbNԁCS݃bNԁCݗDx}XNSԂ
 *  ĂяoƁD
 */
extern bool_t make_active(uint_t ipri);

/*
 *  w肵NDx̃^XNx~Ԃǂ̃eXg
 *
 *  ipriŎw肵NDx^XNx~Ԃł
 *  trueȊOis\ԁCs\ԁjłfalseԂD
 *
 *  {֐CPUbNԁCS݃bNԁCݗDx}XNSԂ
 *  ĂяoƁD
 */
extern bool_t test_dormant(uint_t ipri);

/*
 *  ōD揇ʃ^XÑT[`
 *
 *  s\Ԃ̃^XN̒łD揇ʂ^XN̏Dx
 *  ԂD
 *
 *  {֐CPUbNԁCS݃bNԁCݗDx}XNSԂ
 *  ĂяoƁD
 */
extern uint_t search_schedtsk(void);

/*
 *  ^XN̎s
 *
 *  ipriŎw肵NDx^XNsD
 *  {֐s^XNT[rXR[oR
 *  ċAIɌĂ΂邱ƂD
 *
 *  {֐CPUbNԁCS݃bNԁCݗDx}XNSԂ
 *  ĂяoƁD
 */
extern void run_task(uint_t ipri);

/*
 *  ^XNfBXpb`
 *
 *  J[lɌĂяoCōD揇ʂƂȂ^XNsD
 *
 *  {֐CPUbNԁCS݃bNԁCݗDx}XNSԂ
 *  ĂяoƁD
 *  ȂC{֐̓^[ȂD
 *  
 */
extern void dispatcher(void) NoReturn;

/*
 *  ^XN̋NDx擾(^XNReLXgp)
 *
 *  tskidŎw肵^XN̋NDx擾D
 *  tskidTMIN_TSKIDȏCtmax_tskidȉ̒lCTSK_SELF
 *  w肵Ȃ΂ȂȂD
 */
extern uint_t get_ipri_self(ID tskid);

/*
 *  ^XN̋NDx擾(^XNReLXgp)
 *
 *  tskidŎw肵^XN̋NDx擾D
 *  tskidTMIN_TSKIDȏCtmax_tskidȉ̒lŎw肵Ȃ΂ȂȂD
 */
extern uint_t get_ipri(ID tskid);


/* NvL[COrbg}bv̑ */
#define ACTQUE_BIT(ipri)			(1U << (ipri))

/* NvL[CÕZbg */
Inline
void actque_set(uint_t ipri)
{
	actque_bitmap |= ACTQUE_BIT(ipri);
}

/* NvL[CÕNA */
Inline
void actque_clear(uint_t ipri)
{
	actque_bitmap &= ~ACTQUE_BIT(ipri);
}

/* NvL[CÕ`FbN */
Inline
bool_t actque_test(uint_t ipri)
{
	return ((actque_bitmap & ACTQUE_BIT(ipri)) != 0U);
}


#endif /* TOPPERS_TASK_H */
